-- Grass gatherer by Hakori
-- Based upon Clay gatherer by Makazi
-- You need to have camera F8F8 zoomed all the way in,
-- You also need a WH nearby, and water where you start.
-- It always walks in the direction mentioned first on the button.
-- Walking pattern may drift due to lag. Manual correction may be needed from time to time.

dofile("screen_reader_common.inc");
dofile("ui_utils.inc");
dofile("flax_common.inc");

move_delay = 500;
per_click_delay = 10;
MaxGrass = 0;
GrassCounter = 0;
moveDirection = 0;
moveCounter = 1;

function moveCharacter()
  srReadScreen();
  local xyCenter = getCenterPos();

    if moveDirection == 0 then

      if directionCounter == 0 then
	srClickMouseNoMove(xyCenter[0]+300, xyCenter[1], 0);

      else
	srClickMouseNoMove(xyCenter[0]-300, xyCenter[1], 0);	
      end

      lsSleep(move_delay);
    end

    if moveDirection == 1 then

      if directionCounter == 0 then
	srClickMouseNoMove(xyCenter[0], xyCenter[1]+300, 0);

      else
	srClickMouseNoMove(xyCenter[0], xyCenter[1]-300, 0);	
      end

      lsSleep(move_delay);
    end

    if moveDirection == 2 then

      if directionCounter == 0 then
	srClickMouseNoMove(xyCenter[0]-300, xyCenter[1], 0);

      else
	srClickMouseNoMove(xyCenter[0]+300, xyCenter[1], 0);	
      end

      lsSleep(move_delay);
    end

    if moveDirection == 3 then

      if directionCounter == 0 then
	srClickMouseNoMove(xyCenter[0], xyCenter[1]-300, 0);

      else
	srClickMouseNoMove(xyCenter[0], xyCenter[1]+300, 0);	
      end

      lsSleep(move_delay);
    end

    if moveCounter < 5 then
      directionCounter = 1;

    else
      directionCounter = 0;
    end

    if moveCounter > 8 then
      moveCounter = 0;

    else
      moveCounter = moveCounter + 1;
    end
end

function clickImage()
if image_name == "UnPin.png" then
  x=30;
  y=30;

elseif image_name == "gathermud.png" then
  x=150;
  y=90;

else
  x=9;
  y=9;
end
	
srReadScreen();
xyWindowSize = srGetWindowSize();	
local buttons = findAllImages(image_name);

if #buttons == 0 then
  statusScreen("Searching for " .. image_name .. "...");
  lsSleep(per_click_delay);

else
  for i=1, #buttons do
    srClickMouseNoMove(buttons[i][0]+x, buttons[i][1]+y, right_click);
    lsSleep(per_click_delay);
  end

  statusScreen(image_name .. " found and clicked.");
  lsSleep(per_click_delay);		

  if image_name == "grass.png" then
    statusScreen("Collecting grass..");
    GrassCounter = GrassCounter + 1;
    lsSleep(per_click_delay);
  end
end	
end

function doit()
-- Ask about how much grass to gather before stashing
while MaxGrass < 1 do
  MaxGrass =promptNumber("Amount of Grass to collect?");
end

-- Ask what direction your character should move
while not is_done do
  statusScreen("Select line of direction.");

  if lsButtonText(10, 100, 0, 250, 0xFFFFFFff, "West - East") then
    moveDirection = 0;
    is_done = 1;
  end

  if lsButtonText(10, 140, 0, 250, 0xFFFFFFff, "North - South") then
    moveDirection = 1;
    is_done = 1;
  end

  if lsButtonText(10, 180, 0, 250, 0xFFFFFFff, "East - West") then
    moveDirection = 2;
    is_done = 1;
  end

  if lsButtonText(10, 220, 0, 250, 0xFFFFFFff, "South - North") then
    moveDirection = 3;
    is_done = 1;
  end
end
	
-- Get ATITD window	
askForWindow("Script Author: Hakori\n\nStand in a place with Grass icon.\nPlease make sure to F8F8 before starting");

-- Start gathering, stashing and filling water
while 1 do
  if GrassCounter == MaxGrass then
    break
  end

  image_name = "grass.png"
  clickImage();

  moveCharacter();

  -- Check if it accidently hit the Mud icon
  image_name="gathermud.png";
  clickImage();
end
end
